## Use
### Andorid
### iOS
come in soon....
### Web
.... web isn't suppot

## support data types

the types is the same to flutter [support platform data](https://flutter.dev/docs/development/platform-integration/platform-channels#codec)

Dart | Java | Kotlin | Obj-C | Swift
|  ----  | ---- | ---- | ----|----|
null | null | null | nil (NSNull when nested) | nil
bool | java.lang.Boolean | Boolean | NSNumber numberWithBool: | NSNumber(value: Bool)
int | java.lang.Integer | Int | NSNumber numberWithInt: | NSNumber(value: Int32)
int, if 32 bits not enough | java.lang.Long | Long | NSNumber numberWithLong: | NSNumber(value: Int)
double | java.lang.Double | Double | NSNumber numberWithDouble: | NSNumber(value: Double)
String | java.lang.String | String | NSString | String
Uint8List | byte[] | ByteArray | FlutterStandardTypedData typedDataWithBytes: | FlutterStandardTypedData(bytes: Data)
Int32List | int[] | IntArray | FlutterStandardTypedData typedDataWithInt32: | FlutterStandardTypedData(int32: Data)
Int64List | long[] | LongArray | FlutterStandardTypedData typedDataWithInt64: | FlutterStandardTypedData(int64: Data)
Float64List | double[] | DoubleArray | FlutterStandardTypedData typedDataWithFloat64: | FlutterStandardTypedData(float64: Data)
List | java.util.ArrayList | List | NSArray | Array
Map | java.util.HashMap | HashMap | NSDictionary | Dictionary


## Protocol Json
### Flutter to Native

Flutter to native json file will save in **channels/flutter2native** dir.<br/> All type use flutter desc, json format desc:

|  Key   | Desc | Must|
|  ----  | ---- | ---- |
| package  | package | must
| name  | create protocol name | must
| methods  | methods, array| must

the <b>method</b> :

|  Key   | Desc | Must|
|  ----  | ---- | ---- |
| name  | name | must
| return  | return type, if method has return value | opt
| arguments  | arguments, array, if method has args| opt


the <b>arguments</b> :

|  Key   | Value |
|  ----  | ---- |
| argument type  | argument name

For example:

```json
{
  "package": "com.example.protocol",
  "name": "IShare",
  "methods": [
    {
      "name": "getFeedList",
      "return": "List<String>",
      "arguments": [
        {
          "String": "teamId"
        },
        {
          "String": "userId"
        }
      ]
    },
    {
      "name": "deleteFeed",
      "arguments": [
        {
          "String": "feedId"
        },
        {
          "String": "userId"
        }
      ]
    }
  ]
}
```

### Native to Flutter

native to flutter json file will save in **channels/native2flutter** dir. json format desc:


|  Key   | Desc | Must|
|  ----  | ---- | ---- |
| package  | package | must
| name  | create protocol name | must
| methods  | methods, array| must

the <b>method</b> :

|  Key   | Desc | Must|
|  ----  | ---- | ---- |
| name  | name | must
| return  | return type, if method has return value <br/><b>because native invoke flutter must in main thread, so the return value will use callback invoke<b/>| opt
| arguments  | arguments, array, if method has args| opt


the <b>arguments</b> :

|  Key   | Value |
|  ----  | ---- |
| argument type  | argument name

For example:

```json
{
  "package": "com.example.protocol",
  "name": "I",
  "methods": [
    {
      "name": "getFeedList",
      "return": "String",
      "arguments": [
        {
          "String": "teamId"
        },
        {
          "String": "userId"
        }
      ]
    },
    {
      "name": "deleteFeed",
      "arguments": [
        {
          "String": "feedId"
        },
        {
          "String": "userId"
        }
      ]
    }
  ]
}
```

## ErrorCode
|  Code   | Desc
|  ----  | ----
| 400  | can't found channel
| 401  | can't found method
| 402  | method's args can not match


